{ startovn slo 14 }

{ Ovldn: ipkami, mezerou se ot se sirkou, enterem se thne,
  ? - npovda }

program safety_matches;
uses crt,graph;
const
  okraj_y:word=40;
  mx=10;
  max_x=2*mx+1;
  max_y=mx+1;
  sirka=5;   {kurzoru}
  kurzor=11;  {barva}
  aktivni=9; {barva}
  space='';
type
  TZapalka=(zadna,hrace1,hrace2,done1,done2);
  TPole=array [1..max_x,1..max_y] of TZapalka;
  TData=record
    jmeno:string;
    skore:word;
  end;
var
  zero,tah,akce,horiz,hrac2:boolean;
  znak:char;
  GraphDriver, GraphMode: Integer;
  ErrorCode: Integer;
  n,delka,okraj_x,a,b,c,kx,ky,skx,sky,my_max_x,my_max_y:word;
  pole:TPole;
  score:array [1..2] of word;
  cache:array [1..2] of integer;   { cache pro score }
  tab:array [1..11] of TData;
  f:text;
  name:string;

procedure graphon;    { nahod grafiku }
begin
  GraphDriver := Detect;
  InitGraph(GraphDriver, GraphMode, 'g:\14');
  ErrorCode := GraphResult;
  if ErrorCode <> grOk then
  begin
    Writeln('Chyba grafiky: ', GraphErrorMsg(ErrorCode));
    Readln;
    Halt(1);
  end;
end;

procedure graphoff;
begin
  CloseGraph;
end;

procedure message(ret:string);      { zprva }
begin
  setcolor(0);
  OutTextXY(1,1,space);
  setcolor(15);
  OutTextXY(1,1,ret);
  sound(2000);
  delay(100);
  nosound;
  readkey;
  setcolor(0);
  OutTextXY(1,1,space);
end;



{ Grafick pozice }

function posgx(xx:word):word;
begin
  posgx:=okraj_x+(xx-1)*delka;
end;

function posgy(yy:word):word;
begin
  posgy:=okraj_y+(yy-1)*delka;
end;


{ Pozice v poli }

function pospx(xx:word; hor:boolean):word;
begin
  { hor - horizontln }
  pospx:=xx*2-byte(not hor);
  {if (xx*2-byte(not horiz)>2*mx+1) or (xx*2-byte(not horiz)<1) then
  begin
  writeln('???'); halt;
  end;}
end;

function pospy(yy:word):word;
begin
  pospy:=yy;
  {if (yy>mx+1) or (yy<1) then
  begin
  writeln('???'); halt;
  end;}
end;


procedure clear;                      { vyist pole }
begin
  for b:=1 to n+1 do
  begin
    for a:=1 to n+1 do
    begin
      if a<=n then
      {horiz}
      begin
        pole[pospx(a,true),pospy(b)]:=zadna;
      end;
      if b<=n then
      {vert}
      begin
        pole[pospx(a,false),pospy(b)]:=zadna;
      end;
    end;
  end;
end;

function clr(dt:TZapalka):byte;
begin
  if dt=zadna then clr:=15;
  if dt=hrace1 then clr:=10;
  if dt=hrace2 then clr:=12;
  if dt=done1 then clr:=2;
  if dt=done2 then clr:=4;
end;

procedure view_score;                  { zobraz aktuln skore }
var scor:string;
begin
  setcolor(0);
  OutTextXY(0,getmaxy-20,space);
  setcolor(clr(hrace1));
  if not hrac2 then setcolor(aktivni);
  OutTextXY(0,getmaxy-20,'Hr 1:');
  str(score[1],scor);
  setcolor(clr(hrace1));
  OutTextXY(100,getmaxy-20,scor);

  setcolor(0);
  OutTextXY(300,getmaxy-20,space);
  setcolor(clr(hrace2));
  if hrac2 then setcolor(aktivni);
  OutTextXY(300,getmaxy-20,'Hr 2:');
  str(score[2],scor);
  setcolor(clr(hrace2));
  OutTextXY(400,getmaxy-20,scor);
end;



procedure show;                         { zobraz vtinu grafiky }
begin
  {if skx>0 then
    for a:=posgy(sky)-sirka to posgy(sky)+sirka do
      for b:=posgx(skx)-sirka to posgx(skx)+sirka do
      begin
        putpixel(b,a,0);
      end;
  skx:=kx;
  sky:=ky;}

  for b:=1 to n+1 do
    for a:=1 to n+1 do
    begin
      if a<=n then
      {horiz}
      begin
        setcolor(clr(pole[pospx(a,true),pospy(b)]));
        line(posgx(a),posgy(b),posgx(a+1),posgy(b));
      end;
      if b<=n then
      {vert}
      begin
        setcolor(clr(pole[pospx(a,false),pospy(b)]));
        line(posgx(a),posgy(b),posgx(a),posgy(b+1));
      end;
    end;
  setcolor(aktivni);
  if horiz then line(posgx(kx),posgy(ky),posgx(kx+1),posgy(ky))
  else line(posgx(kx),posgy(ky),posgx(kx),posgy(ky+1));
  setcolor(clr(TZapalka(byte(hrac2)+1)));
  if horiz then line(posgx(kx)+delka div 4,posgy(ky),posgx(kx+1)-delka div 4,posgy(ky))
  else line(posgx(kx),posgy(ky)+delka div 4,posgx(kx),posgy(ky+1)-delka div 4);
{  for a:=posgy(ky)-sirka to posgy(ky)+sirka do
    for b:=posgx(kx)-sirka to posgx(kx)+sirka do
    begin
      putpixel(b,a,kurzor);
    end;                   }
  view_score;
end;






function rovnajise(p1,p2:TZapalka):boolean;
var result:boolean;
begin
  result:=false;
  if p1=p2 then result:=true;
  if (p1=hrace1) and (p2=done1) then result:=true;
  if (p1=done1) and (p2=hrace1) then result:=true;
  if (p1=hrace2) and (p2=done2) then result:=true;
  if (p1=done2) and (p2=hrace2) then result:=true;
  rovnajise:=result;
end;

function citoje(p:TZapalka):TZapalka;
begin
  citoje:=p;
  if p in [done1..done2] then citoje:=TZapalka(byte(p)-2);
end;



procedure test(interv:boolean);         { testuje tverce }
var
  ok,done:boolean;
begin
  for a:=1 to 2 do cache[a]:=0;
  for b:=1 to n do
    for a:=1 to n do
    begin
      ok:=pole[pospx(a,false),pospy(b)]<>zadna;
      done:=true;
      for c:=pospx(a,false) to pospx(a,true) do
      begin
        if not rovnajise(pole[c,pospy(b)],pole[c+1,pospy(b)]) then ok:=false;
        if not (pole[c,pospy(b)] in [done1..done2]) then done:=false;
        if not (pole[c+1,pospy(b)]  in [done1..done2]) then done:=false;
      end;
      if not rovnajise(pole[pospx(a,false),pospy(b)],pole[pospx(a,true),pospy(b+1)]) then ok:=false;
      if not (pole[pospx(a,true),pospy(b+1)] in [done1..done2]) then done:=false;
      if done then ok:=false;
      if ok then
      begin
        inc(cache[byte(citoje(pole[pospx(a,false),pospy(b)]))]);
        if interv then for c:=pospx(a,false) to pospx(a+1,false) do if pole[c,pospy(b)]<done1 then inc(pole[c,pospy(b)],2);
        if interv then if pole[pospx(a,true),pospy(b+1)]<done1 then inc(pole[pospx(a,true),pospy(b+1)],2);

      end;
    end;
end;

procedure hraj;                   { dl tahy a podobn }
begin
  if pole[pospx(kx,horiz),pospy(ky)]<>zadna then
    begin message('Toto msto je ji obsazen.'); exit; end;
  pole[pospx(kx,horiz),pospy(ky)]:=TZapalka(byte(hrac2)+1);
  test(true);
  if cache[1]>0 then begin sound(1000); delay(50); nosound; end;
  for a:=1 to 2 do inc(score[a],cache[a]);
  hrac2:=not hrac2;
end;



procedure help;
var
  aa,bb,sa,sb:word;
  hor:boolean;
  max:word;
begin
  max:=0;
  for bb:=1 to n+1 do
    for aa:=1 to n+1 do
    begin
      if aa<=n then
      {horiz}
      begin
        if pole[pospx(a,true),pospy(b)]=zadna then
        begin
          pole[pospx(a,true),pospy(b)]:=TZapalka(byte(hrac2)+1);
          test(false);
          if cache[byte(hrac2)]>max then
          begin
            max:=cache[byte(hrac2)];
            sa:=aa;
            sb:=bb;
            hor:=true;
          end;
          pole[pospx(a,true),pospy(b)]:=zadna;
        end;
      end;
      if bb<=n then
      {vert}
      begin
        if pole[pospx(a,false),pospy(b)]=zadna then
        begin
          pole[pospx(a,false),pospy(b)]:=TZapalka(byte(hrac2)+1);
          test(false);
          if cache[byte(hrac2)]>max then
          begin
            max:=cache[byte(hrac2)];
            sa:=aa;
            sb:=bb;
            hor:=false;
          end;
          pole[pospx(a,false),pospy(b)]:=zadna;
        end;
      end;
    end;
  kx:=sa;
  ky:=sb;
  horiz:=hor;
  tah:=true;
  akce:=true;
  hraj;
end;


procedure klaves;                 { obsluhuje klvesnici }
begin
  znak:=#0;
  zero:=false;
  while znak=#0 do
  begin
    znak:=readkey;
    if znak=#0 then zero:=not zero;
  end;
  if zero then
  begin
    if znak='M' then inc(kx);
    if znak='K' then dec(kx);
    if znak='P' then inc(ky);
    if znak='H' then dec(ky);
    if (znak='M') or (znak='K') or (znak='P') or (znak='H') then akce:=true;
    if kx<1 then kx:=1;
    if kx>n+1 then kx:=n+1;
    if ky<1 then ky:=1;
    if ky>n+1 then ky:=n+1;
    if horiz and (kx>n) then horiz:=not horiz;
    if not horiz and (ky>n) then horiz:=not horiz;
    if (kx>n) and (ky>n) then begin kx:=n; end;
  end
  else
  begin
    if znak='?' then help;
    if znak=#13 then tah:=true;
    if znak=#32 then
      if (horiz and not (ky>n)) or (not horiz and not (kx>n)) then
      begin horiz:=not horiz; akce:=true; end;
  end;
end;




function full:boolean;          { je pln s? }
var result:boolean;
begin
  result:=true;
  for b:=1 to n+1 do
    for a:=1 to n+1 do
    begin
      if a<=n then
      {horiz}
      begin
        if pole[pospx(a,true),pospy(b)]=zadna then
          begin result:=false; full:=false; exit; end;
      end;
      if b<=n then
      {vert}
      begin
        if pole[pospx(a,false),pospy(b)]=zadna then
          begin result:=false; full:=false; exit; end;
      end;
    end;
  full:=result;
end;

procedure load;
begin
  assign(f,'score.txt');
  {$I-}
  reset(f);
  {$I+}
  if IOResult<>0 then
  begin
    for a:=1 to 10 do
    begin
      tab[a].jmeno:='';
      tab[a].skore:=0;
    end;
    exit;
  end;
  {$I-}
  a:=0;
  repeat
  inc(a);
  readln(f,tab[a].jmeno);
  readln(f,tab[a].skore);
  until eof(f) or (a>=10);
  close(f);
  {$I+}
end;


procedure save;
begin
  assign(f,'score.txt');
  {$I-}
  rewrite(f);
  {$I+}
  {$I-}
  a:=0;
  repeat
  inc(a);
  writeln(f,tab[a].jmeno);
  writeln(f,tab[a].skore);
  until a>=10;
  close(f);
  {$I+}
end;

procedure view;
begin
  writeln('Nejlepch deset');
  a:=0;
  repeat
  inc(a);
  write(tab[a].jmeno);
  gotoXY(50,wherey);
  writeln(tab[a].skore);
  until a>=10;
end;



procedure add(jmeno:string;skore:word);     { pid jmno a skore }
var
  ret:string;
  sk:word;
begin
  tab[11].jmeno:=jmeno;
  tab[11].skore:=skore;
  for a:=1 to 10 do
    for b:=1 to 10 do
    begin
      if tab[b].skore<tab[b+1].skore then
      begin
        ret:=tab[b+1].jmeno;
        tab[b+1].jmeno:=tab[b].jmeno;
        tab[b].jmeno:=ret;

        sk:=tab[b+1].skore;
        tab[b+1].skore:=tab[b].skore;
        tab[b].skore:=sk;
      end;
    end;
end;



begin
  load;
  hrac2:=false;
  n:=0;
  kx:=1;
  ky:=1;
  skx:=0;
  for a:=1 to 2 do score[a]:=0;
  horiz:=true;
  while (n<2) or (n>10) do
  begin
    write('Zadejte rozmr strany n [2..10]: ');
    readln(n);
  end;
  graphon;
  delka:=round((getmaxy-2*okraj_y)/n);   { vypote vhodn rozmr jedn sirky }
  okraj_x:=round((getmaxx-n*delka)/2);    { vypote vhodn x-ov okraj }
  clear;
  show;

  repeat
  akce:=false;
  tah:=false;
  klaves;
  if tah then akce:=true;
  if tah then hraj;
  if akce then show;
  until (znak=#27) or full;
  graphoff;
  for c:=1 to 2 do
  begin
    writeln('Zadejte jmno, hri ',c,':');
    readln(name);
    add(name,score[c]);
  end;
  save;
  view;
end.
